#!/usr/bin/perl -w

use strict;

$ARGV[0] or die "Usage: symlink-countries <base dir>\n";

chdir $ARGV[0] or die "Could not change to base directory";

my @terms=qw(argv auto hard lase shel wash);
my $termre="(?i:" . join("|", @terms) . ")";
my @locs= qw(anderm bruchs colmar innsbr lugano);
my $locre="(?i:" . join("|", @locs) . ")";

my $symlinkdir= "symlinks";

unless( -d $symlinkdir ) {
  mkdir $symlinkdir or die "Could not create directory $symlinkdir";
}

chdir $symlinkdir or die "Could not descend into directory $symlinkdir";

for my $loc (@locs) {
  my ($locdir)= grep -d, glob "../*$loc*";
  unless( $locdir && -d $locdir ) {
    print STDERR "No directory containing `$loc' found.\n";
    next;
  }
  my @alllists= glob "$locdir/*.list";
  my @lists50= grep /50/, @alllists;
  my @lists10= grep /10/, @alllists;
  my @otherlists= grep ! /10|50/, @alllists;
#  print "number of 10-result lists: ", scalar(@lists10), 
#        ",  number of 50-result lists: ", scalar(@lists50), "\n";
  if( @lists10 > @terms ) {
    @lists10= grep /10\.list$/, @lists10;
  }
  elsif( @lists10 < @terms ) {
    @lists10= grep /$termre/, @otherlists;
  }
  if( @lists50 > @terms ) {
    @lists50= grep /50\.list$/, @lists50;
  }
#  print "after correction: number of 10-result lists: ", scalar(@lists10), 
#        ",  number of 50-result lists: ", scalar(@lists50), "\n";
  if( @lists10 != @terms ) {
    print STDERR "Wrong number of list files with 10 results in $locdir.\n";
  }
  if( @lists50 != @terms ) {
    print STDERR "Wrong number of list files with 50 results in $locdir.\n";
  }
  next if @lists10 != @terms || @lists50 != @terms;
  for my $t (@terms) {
    my ($f)= grep /$t/, @lists10;
    symlink $f, "$t-$loc-10.list";
  }
  for my $t (@terms) {
    my ($f)= grep /$t/, @lists50;
    symlink $f, "$t-$loc-50.list";
  }
}

